Unit SF40R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF23C_p, UTSF12_p, SF39R_p;

function SF40R(X :Real; P :Real; var IERR :Integer): Real;

implementation

function SF40R(X :Real; P :Real; var IERR :Integer): Real;
var
IERR1 :Integer;
R1,R2,EPS :Real;
const
PMAX :Real = 21.4;
SYS059 :Real = 3.4E38;
SYS089 :Real = 1.0E-6;
label
_1,_2,_3,_4;
begin
{ Result -    SF40R  FORTRANe }
if ( X >= 0.E0 ) 
 then goto _1;
IERR := 65;
Result := SYS059;
goto _4;
_1:
if ( P > 0.E0 )
 then goto _2;
IERR := 66;
Result := SYS059;
goto _4;
_2:
if ( P <= PMAX ) 
 then goto _3;
IERR := 66;
Result := SYS059;
goto _4;
_3:
IERR := 0;
EPS := SYS089;
SF23C(P,0.E0,R1,R2,EPS,1,IERR1);
Result := SF39R(X,P,IERR1)*R1;
_4:
if ( IERR <> 0 ) 
 then UTSF12(IERR,40);
exit;
end;

end.
